<?php
	/*
	 * Module:	bta_add.php
	 * Description: This is the add torrent screen of the administrative interface.
	 * 		This module inserts a torrent's details in the database so it can
	 * 		be tracked.
	 *   		Various fields added and changed sql statements to update info.. also added 
	 *		session tracking so you don't have to enter user/pass all the time.
	 *		Code was used from the the DeHackEd's script for adding torrents as well.
	 *
	 * Author:	danomac
	 * Written:	17-Febrary-2004
	 *
	 * Copyright (C) 2004 danomac
	 *
	 * This program is free software; you can redistribute it and/or modify
	 * it under the terms of the GNU General Public License as published by
	 * the Free Software Foundation; either version 2 of the License, or
	 * (at your option) any later version.
	 *
	 * This program is distributed in the hope that it will be useful,
	 * but WITHOUT ANY WARRANTY; without even the implied warranty of
	 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	 * GNU General Public License for more details.
	 *
	 * You should have received a copy of the GNU General Public License
	 * along with this program; if not, write to the Free Software
	 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
	 */
	session_start();
	header("Cache-control: private");

	/*
	 * List of the external modules required
	 */
	require_once ("../config.php");
	require_once ("../funcsv2.php");
	require_once ("../version.php");
	require_once ("../BDecode.php");
	require_once ("../BEncode.php");
	require_once ("bta_funcs.php");

	/*
	 * Get the current script name.
	 */
	$scriptname = $_SERVER["PHP_SELF"];

	/*
	 * Get the client's IP address. Used for verifying access.
	 */
	$ip = str_replace("::ffff:", "", $_SERVER["REMOTE_ADDR"]);

	/*
	 * Check to make sure person is logged in, and that the session
	 * is actually theirs.
	 */
	if (!admIsLoggedIn($ip)) {
		admShowError("You can't access this page directly.",
			     "You don't appear to be logged in. Use admin/index.php to login to the administrative interface.",
			     $adm_pageerr_title);
		exit;		
	}

	/*
	 * Group admin: are they actually allowed to view this page?
	 * If not, redirect them back to main
	 */
	if (!($_SESSION["admin_perms"]["add"] || $_SESSION["admin_perms"]["root"])) {
		admShowMsg("You don't have permission to view this page.", "Redirecting to the main administration panel.",
			       $adm_page_title, true, "bta_main.php", 3);
	}

	/*
	 * Set the message to an empty string. If there is content in this string, it
	 * is displayed in the table. Also sets an "error" variable so skipping processing
	 * can be done.
	 */
	$statusMsg = "";
	$addError = false;

	/*
	 * If the button was pressed, let's attempt to add the torrent.
	 */
	if (isset($_POST["addtorrent"])) {
		/*
		 * Connect to the database
		 */
		if ($GLOBALS["persist"])
			$db = @mysql_pconnect($dbhost, $dbuser, $dbpass) or die("<HTML><BODY><FONT COLOR=\"red\">Couldn't connect to database. Incorrect username/password?</FONT></BODY></HTML>");
		else
			$db = @mysql_connect($dbhost, $dbuser, $dbpass) or die("<HTML><BODY><FONT COLOR=\"red\">Couldn't connect to database. Incorrect username/password?</FONT></BODY></HTML>");
		mysql_select_db($database) or die("Can't open the database.");

		/*
		 * If a file was uploaded, get info about the torrent.
		 * If uploading wasn't available, get the torrent size and hash from the form.
		 */
		if (isset($_FILES["torrentfile"])) {
			/*
			 * Okay, let's see if the torrent upload was ok. PHP will delete the file at the end of the
			 * session if it isn't used, so only if the upload is OK will we process it.
			 */
			switch ($_FILES["torrentfile"]["error"]) {
				case UPLOAD_ERR_OK:	//file uploaded ok
					/*
					 * Make sure the file was uploaded through the POST form
					 */
					if (is_uploaded_file($_FILES["torrentfile"]["tmp_name"])) {
						/*
						 * Is it actually a torrent?
						 */
						if (substr($_FILES["torrentfile"]["name"], -8) == '.torrent') {
							/*
							 * The HTML Anchor character (#), the control character (^), and the semicolon (;) is not allowed in torrent names, 
							 * so check for it and report an error if one is found.
							 */
							if (!stristr($_FILES["torrentfile"]["name"], "#") && !stristr($_FILES["torrentfile"]["name"], "^") && !stristr($_FILES["torrentfile"]["name"], ";")) {
								/*
								 * Check to see if the size is too large. If it is, terminate with an error.
								 */
								if ($_FILES["torrentfile"]["size"] < $GLOBALS["max_torrent_size"]) {
									/*
									 * Okay, it seems to be good. Open, the file and decode it, and close it.
									 */
									$fd = fopen($_FILES["torrentfile"]["tmp_name"], "rb") or die("File upload error 1\n");
									$alltorrent = fread($fd, filesize($_FILES["torrentfile"]["tmp_name"]));
									$array = BDecode($alltorrent);
									fclose($fd);
		
									/*
									 * Make sure it's been decoded properly.
									 */
									if (!isset($array)) {
										$statusMsg = "There was an error handling your uploaded torrent. The parser didn't like it.";
										$addError = true;
									}
									if (!$array && !addError) {
										$statusMsg = "There was an error handling your uploaded torrent. The parser didn't like it.";
										$addError = true;
									}

									/*
									 * Check to see if this is an external torrent, and then check if user is allowed to add
									 * external torrents. If they are not allowed, abort.
									 */
									if (strcmp($GLOBALS["my_tracker_announce"], $array["announce"]) != 0) {
										/*
										 * This appears to be an external torrent, check permissions
										 */
										if (!($_SESSION["admin_perms"]["addext"] || $_SESSION["admin_perms"]["root"])) {
											$statusMsg = "You are not allowed to add external torrents; check your announce url.";
											$addError = true;
										}
									}

									/*
									 * Okay, if it's been decoded OK, so get the hash, calculate the file size,
									 * and if enabled, copy it to the specified folder.
									 */					
									if (!$addError) {
										$hash = sha1(BEncode($array["info"]));
										$filesize = $array["info"]["piece length"] * (strlen($array["info"]["pieces"]) / 20) / 1048576;
										$filesize = round($filesize, 2);
		
										/*
										 * Move the file, if enabled. docroot is /dev/null by default. so let's not
										 * bother moving it if the http document root isn't specified.
										 * A variable is set if it has been copied. If it is copied successfully,
										 * spaces will be filled with '_' and the URL will be set automagically.
										 */ 
										$copiedTorrent = false;
										if ($GLOBALS["allow_torrent_move"]) {
											/*
											 * It's allowed, check to see if user requested it
											 */
											if (isset($_POST["copytorrent"])) {
												if (strcmp($_POST["copytorrent"], "enabled") == 0) {
													/*
													 * Build a path using the html document root and the requested subfolder.
													 */
													$movetopath = $_SERVER["DOCUMENT_ROOT"] . "/" . $GLOBALS["torrent_folder"];
													$movetopath = stripslashes($movetopath);

													/*
													 * Take the original filename, and replace all the spaces with underscores.
													 */
													$copyFilename = stripslashes($_FILES["torrentfile"]["name"]);
													$copyFilename = ereg_replace(" ","_", $copyFilename);

													/*
													 * Move the file, supressing warnings. If the file does NOT copy to the dest
													 * folder, it is a permissions problem. The apache processes MUST have write
													 * access to the torrent folder.
													 */
													$movetopath .= "/" . $copyFilename;
													@move_uploaded_file($_FILES["torrentfile"]["tmp_name"],  $movetopath);

													/*
													 * Now that it's moved, set the URL to that new file name, and set the
													 * flag to true, so it isn't accidentally overwritten later.
													 */		
													$url = "http://" . $_SERVER["HTTP_HOST"] . "/" . $GLOBALS["torrent_folder"] . "/" . $copyFilename;
													$copiedTorrent = true;
												}
											}
										}
									}
								} else {
									$statusMsg = "Torrent size is too large.";
									$addError = true;
								}
							} else {
								$statusMsg = "Torrents CANNOT contain a HTML Anchor character (#), a control character (^), or a semicolon (;) in the filename.";
								$addError = true;
							}
						} else {
							$statusMsg = "Only torrents can be uploaded.";
							$addError = true;
						}
					}
					/*
					 * Remove the file, if we didn't copy it somewhere.
					 */
					if (!$copiedTorrent) unlink($_FILES["torrentfile"]["tmp_name"]);
					break;
				case UPLOAD_ERR_INI_SIZE:	//php settings denied upload (php.ini)
					$statusMsg = "Upload failed. Torrent size is too big. Please try again.";
					$addError = true;					
					break;
				case UPLOAD_ERR_FORM_SIZE:	//size specified in form exceeded
					$statusMsg = "Upload failed. Torrent size is too big. Please try again.";
					$addError = true;					
					break;
				case UPLOAD_ERR_PARTIAL:	//file upload incomplete
					$statusMsg = "Upload failed. Only a part of the torrent was received. Please try again.";
					$addError = true;
					break;
				case UPLOAD_ERR_NO_FILE:	//no file was uploaded
					$statusMsg = "Upload failed. No file specified.";
					$addError = true;
					break;
			}
		} else {
			/*
			 * No upload, get the file size and the hash from the form.
			 * Ensure the file size is actually numeric.
			 */
			$hash = strtolower($_POST["hash"]);
			if (isset($_POST["filesize"])) {
				$filesize = $_POST["filesize"];
				if (!is_numeric($filesize)) {
					$filesize = 0;
				} else {
					$filesize = round($filesize / 1048576, 2);
				}
			} else
				$filesize = 0;
		}

		/*
		 * If there were no processing errors, check the rest of the
		 * data on the form itself.
		 */
		if (!$addError) {
			/*
			 * Check all the text fields in the form. If something was set,
			 * copy it into a variable.
			 */
			if (isset($_POST["filename"]))
				$filename=$_POST["filename"];
			else
				$filename = "";
	
			if (isset($_POST["urlmirror"]))
				$urlmirror = $_POST["urlmirror"];
			else
				$urlmirror = "";

			if (isset($_POST["sfv"]))
				$urlsfv = $_POST["sfv"];
			else
				$urlsfv = "";

			if (isset($_POST["md5"]))
				$urlmd5 = $_POST["md5"];
			else
				$urlmd5 = "";

			if (isset($_POST["urlinfo"]))
				$urlinfo = $_POST["urlinfo"];
			else
				$urlinfo = "";

			if (isset($_POST["crcinfo"]))
				$crcinfo = $_POST["crcinfo"];
			else
				$crcinfo = "";	

			if (isset($_POST["category"]))
				$category = $_POST["category"];

			if (isset($_POST["removeurl"]))
				$removeurldate = $_POST["removeurl"];
			else
				$removeurldate = "";	

			if (isset($_POST["indexhidetorrent"]))
				$hidetorrentdate = $_POST["indexhidetorrent"];
			else
				$hidetorrentdate = "";	

			if (isset($_POST["shortdesc"]))
				$shortdesc = $_POST["shortdesc"];
			else
				$shortdesc = "";

			/*
			 * Check to see if it the category is a zero length string
			 * If it is, assume "main" as the category.
			 */
			if (strlen($category)==0) 
				$category = "main";

			/*
			 * Check to see if there is a forced category to use, if
			 * there is use it.
			 */
			if (isset($_SESSION["admin_perms"]["category"]))
				$category = $_SESSION["admin_perms"]["category"];

			/*
			 * If something was entered in the URL box, it overrides any other URL
			 * (even the url when the files is copied, or when the option is checked
			 * to use the URL from the torrent's file name.)
			 */
			if (isset($_POST["url"]))
				if (strlen($_POST["url"]) > 0)
					$url = $_POST["url"];

			/*
			 * If the option to fill in fields using data from the torrent file is checked,
			 * override the filename entered.
			 */	
			if (isset($_POST["autoset"]))
				if (strcmp($_POST["autoset"], "enabled") == 0) {
					if (strlen($filename) == 0 && isset($array["info"]["name"]))
						$filename = $array["info"]["name"];
				}

			/*
			 * Check the dates to make sure they are legitimate dates.
			 * If not, display a warning and don't add it to the database.
			 */
			if (!isDate($removeurldate, true) || !isDate($hidetorrentdate, true)) {
				$statusMsg = "ERROR: A date is invalid. Please use the format yyyy-mm-dd for dates (ie. '2004-03-24')";
			} else {
				/*
				 * Trying to stay HTML compliant is a pain in the ass sometimes.
				 */
				if (!get_magic_quotes_gpc()) {
					/*
					 * PHP isn't adding slashes to the the POST results, so convert the strings
					 * to HTML-compatible and run addslashes to be a compatible query
					 * string
					 */
					$filename = addslashes(htmlentities($filename));
					$url = addslashes(htmlentities($url));
					$urlmirror = addslashes(htmlentities($urlmirror));
					$urlsfv = addslashes(htmlentities($urlsfv));
					$urlmd5 = addslashes(htmlentities($urlmd5));
					$urlinfo = addslashes(htmlentities($urlinfo));
					$shortdesc = addslashes(htmlentities($shortdesc));
					$crcinfo = addslashes(htmlentities($crcinfo));
				} else {
					/*
					 * PHP is adding slashes to the POST results, so we have to remove the
					 * slashes, then make them HTML compatible, then add the slashes
					 * back to be a compatible query string
					 */
					$filename = addslashes(htmlentities(stripslashes($filename)));
					$url = addslashes(htmlentities(stripslashes($url)));
					$urlmirror = addslashes(htmlentities(stripslashes($urlmirror)));
					$urlsfv = addslashes(htmlentities(stripslashes($urlsfv)));
					$urlmd5 = addslashes(htmlentities(stripslashes($urlmd5)));
					$urlinfo = addslashes(htmlentities(stripslashes($urlinfo)));
					$shortdesc = addslashes(htmlentities(stripslashes($shortdesc)));
					$crcinfo = addslashes(htmlentities(stripslashes($crcinfo)));
				}
				/*
				 * Get today's date (for the torrent add date)
				 */
				$today = date("Y-m-d");

				/*
				 * Check who is adding it
				 */
				if ($_SESSION["admin_perms"]["root"]) {
					$addusername = "root";
				} else {
					$addusername = $_SESSION["admin_perms"]["user"];
				}
				/*
				 * Check the hash value to make sure it's valid. If it is, add to the database.
				 */
				if ((strlen($hash) != 40) || !verifyHash($hash)) {
					$statusMsg = "ERROR: Hash value must be exactly 40 hex bytes.";
				} else {
					/*
					 * Build the query string
					 */
					$query = "INSERT INTO namemap (info_hash, 
								filename, 
								url, 
								mirrorurl, 
								info, 
								size, 
								dateadded, 
								crc32, 
								category, 
								sfvlink, 
								md5link, 
								infolink,
								DateToRemoveURL,
								DateToHideTorrent,
								addedby)
								VALUES (\"$hash\", 
									\"$filename\", 
									\"$url\", 
									\"$urlmirror\", 
									\"$shortdesc\", 
									$filesize, 
									\"$today\", 
									\"$crcinfo\", 
									\"$category\", 
									\"$urlsfv\", 
									\"$urlmd5\", 
									\"$urlinfo\",
									\"$removeurldate\",
									\"$hidetorrentdate\",
									\"$addusername\")";

					/* 
					 * Create the torrent table, then update the namemap table.
					 */
					$status = makeTorrent($hash, true);
					quickQuery($query);

					/*
					 * Display the status to the user, change the hidden flag if necessary
					 */
					if ($status) {
						$statusMsg = "Torrent was added successfully.";

						/*
						 * If the user requested the torrent to be hidden, hide it.
						 */
						if (isset($_POST["hidetorrent"]))
							if (strcmp($_POST["hidetorrent"], "enabled") == 0) {
								$query = "UPDATE summary SET hide_torrent=\"Y\" WHERE info_hash=\"$hash\"";
								quickQuery($query);
							}

						/*
						 * Check to see if external tracking needs to be done
						 */
						$addexternal = false;
						if ($GLOBALS["auto_add_external_torrents"] && $GLOBALS["allow_external_scanning"]) {
							if (strcmp($GLOBALS["my_tracker_announce"], $array["announce"]) != 0) {
								$addexternal = true;
							}
						} else {
							if (isset($_POST["externaladd"])) {
								if (strcmp($_POST["externaladd"], "enabled") == 0) {
									if ($GLOBALS["allow_external_scanning"]) {
										if (strcmp($GLOBALS["my_tracker_announce"], $array["announce"]) != 0) {
											$addexternal = true;
										}
									}
								}
							}
						}

						/*
						 * If external tracking is to be done, set up the tables as needed...
						 */
						if ($addexternal) {
							/*
							 * make sure the external tracker is /scrape enabled
	 						 */
							if (strcmp(substr($array["announce"], strlen($array["announce"]) - 9, 9), "/announce") == 0) {
								/*
								 * It is, add/modify tables as needed...
								 */
								$query = "UPDATE summary SET external_torrent=\"Y\" WHERE info_hash=\"$hash\"";
								quickQuery($query);

								/*
								 * Now, we have to replace the '/announce' with '/scrape' in order to get the scrape output
								 * in ext_scan.php later on....
								 */
								$scrapeurl = substr($array["announce"], 0, strlen($array["announce"]) - 9) . "/scrape";

								$now = time();
								$query = "INSERT INTO trk_ext (info_hash, scrape_url, last_update) VALUES (\"$hash\", \"$scrapeurl\", $now)";
								quickQuery($query);
							} else {
								/*
								 * Torrent is still external, so set it in the database, also display a message to the user
								 * stating the stats can't be updated for this torrent.
								 */
								$statusMsg .= "<BR>This torrent is external and does not support /scrape. Stats will not be updated.";
								$query = "UPDATE summary SET external_torrent=\"Y\" WHERE info_hash=\"$hash\"";
								quickQuery($query);
								$query = "UPDATE summary SET ext_no_scrape_update=\"Y\" WHERE info_hash=\"$hash\"";
								quickQuery($query);
							}
						}
					}
					else {
						$statusMsg = "There were some errors. Check if this torrent had been added previously.";
					}
				}
			}
		}
	}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<HTML>
<HEAD>
<META NAME="Author" CONTENT="danomac">
<LINK REL="stylesheet" HREF="admin.css" TYPE="text/css" TITLE="Default">
<?php
	/*
	 * Set the page title.
	 */
	echo "<TITLE>". $adm_page_title . " - Add torrents</TITLE>\r\n";
?>
</HEAD>

<BODY>
<FORM ENCTYPE="multipart/form-data" METHOD="POST" ACTION="bta_add.php">
<TABLE CLASS="tblAdminOuter">
<TR>
<?php
	/*
	 * Display the page heading.
	 */
	echo "\t<TD CLASS=\"pgheading\" COLSPAN=15>".$adm_page_title."<BR>Add torrents</TD>\r\n";
?>
</TR>
<?php admShowURL_Login($ip); ?>
<TR>
	<TD CLASS="data" COLSPAN=15 ALIGN="center"><BR>
	   <A HREF="help/help_add_torrent.php" TARGET="_blank">Need help?</A><BR>
	</TD>
</TR>
<TR>
	<TD CLASS="data" COLSPAN=15 ALIGN="center"><BR>
	   <I>The announce URL for this tracker is</I>: <B><?php echo $GLOBALS["my_tracker_announce"]; ?><BR>
	</TD>
</TR>
<TR>
	<TD ALIGN="center" COLSPAN=15>
	<TABLE BORDER=1>
<?php
	/*
	 * Display the status of the operation, if there is a message.
	 */
	if (strlen($statusMsg) > 0)
		echo "\t<TR>\r\n\t\t<TD ALIGN=\"center\" COLSPAN=15><DIV CLASS=\"status\">$statusMsg</DIV></TD>\r\n\t</TR>";
?>
	<TR>
		<TD COLSPAN=3 ALIGN="center"><A HREF="bta_main.php">Return to Main Administrative screen.</A><BR>&nbsp;</TD>
	</TR>
	<TR>
<?php
	if (function_exists("sha1")) {
		echo "\t\t<TD><INPUT TYPE=\"hidden\" NAME=\"MAX_FILE_SIZE\" VALUE=\"". $GLOBALS["max_torrent_size"] . "\">\r\n";
		echo "\t\tTorrent file:</TD>\r\n\t\t<TD><INPUT TYPE=\"file\" NAME=\"torrentfile\" SIZE=40>&nbsp;Click the <I>Browse</I> button to select a torrent.</TD>";
	} else {
		echo "\t\t<TD>Info Hash:</TD>\r\n\t\t<TD><INPUT TYPE=text NAME=\"hash\" SIZE=40 MAXLENGTH=40>&nbsp;&nbsp;File uploading is not available, enter the hash here.</TD>\r\n";
		echo "\t\t<TD>File Size:</TD>\r\n\t\t<TD><INPUT TYPE=text NAME=\"filesize\" SIZE=40 MAXLENGTH=40>&nbsp;&nbsp;Enter the exact size of the torrent, in bytes.</TD>\r\n";
	}
?>
	</TR>
	<TR>
		<TD>File name:</TD>
		<TD><INPUT TYPE=text NAME="filename" SIZE=40 MAXLENGTH=200>&nbsp;&nbsp;<FONT SIZE=-1><B>(Optional)</B></FONT> If you want to use a different name, enter it here.</TD>
	</TR>
	<TR>
		<TD>URL to torrent:</TD>
		<TD><INPUT TYPE=text NAME="url" SIZE=40 MAXLENGTH=200>&nbsp;&nbsp;<FONT SIZE=-1><B>(Optional)</B></FONT> Enter the URL to the torrent.</TD>
	</TR>
	<TR>
		<TD>Mirror for torrent:</TD>
		<TD><INPUT TYPE=text NAME="urlmirror" SIZE=40 MAXLENGTH=200>&nbsp;&nbsp;<FONT SIZE=-1><B>(Optional)</B></FONT> Enter the URL to the mirror site.</TD>
	</TR>
	<TR>
		<TD>URL to SFV file:</TD>
		<TD><INPUT TYPE=text NAME="sfv" SIZE=40 MAXLENGTH=200>&nbsp;&nbsp;<FONT SIZE=-1><B>(Optional)</B></FONT> Enter the URL to the SFV file.</TD>
	</TR>
	<TR>
		<TD>URL to MD5 file:</TD>
		<TD><INPUT TYPE=text NAME="md5" SIZE=40 MAXLENGTH=200>&nbsp;&nbsp;<FONT SIZE=-1><B>(Optional)</B></FONT> Enter the URL to the MD5 file.</TD>
	</TR>
	<TR>
		<TD>Info URL:</TD>
		<TD><INPUT TYPE=text NAME="urlinfo" SIZE=40 MAXLENGTH=200>&nbsp;&nbsp;<FONT SIZE=-1><B>(Optional)</B></FONT> Enter the URL to an information link.</TD>
	</TR>
	<TR>
		<TD>Description:</TD>
		<TD><INPUT TYPE=text NAME="shortdesc" SIZE=40 MAXLENGTH=200>&nbsp;&nbsp;<FONT SIZE=-1><B>(Optional)</B></FONT> Enter a short description.</TD>
	</TR>
<?php
	if ($_SESSION["admin_perms"]["root"])
		echo "\t<TR>\r\n\t\t<TD>Category:</TD>\r\n\t\t<TD><INPUT TYPE=text NAME=\"category\" SIZE=11 MAXLENGTH=10>&nbsp;&nbsp;<FONT SIZE=-1><B>(Optional)</B></FONT> Enter a category.</TD>\r\n\t</TR>";
	else
		echo "\t<INPUT TYPE=\"hidden\" NAME=\"category\" VALUE=\"". $_SESSION["admin_perms"]["category"]."\">\r\n";
?>
	<TR>
		<TD>CRC32 checksum:</TD>
		<TD><INPUT TYPE=text NAME="crcinfo" SIZE=40 MAXLENGTH=254>&nbsp;&nbsp;<FONT SIZE=-1><B>(Optional)</B></FONT> Enter CRC32 checksum information.</TD>
	</TR>
	<TR>
		<TD>Remove URL:</TD>
		<TD><INPUT TYPE=text NAME="removeurl" SIZE=15 MAXLENGTH=254>&nbsp;&nbsp;<FONT SIZE=-1><B>(Optional)</B></FONT> Enter a date (format: yyyy-mm-dd) to remove the URL from the index page.</TD>
	</TR>
	<TR>
		<TD>Hide from index:</TD>
		<TD><INPUT TYPE=text NAME="indexhidetorrent" SIZE=15 MAXLENGTH=254>&nbsp;&nbsp;<FONT SIZE=-1><B>(Optional)</B></FONT> Enter a date (format: yyyy-mm-dd) to hide the URL from the index page. <B>Note: Torrent stays active.</B></TD>
	</TR>
	<TR>
		<TD ALIGN=CENTER COLSPAN=2><INPUT TYPE="checkbox" NAME="hidetorrent" VALUE="enabled"> Hide this torrent</TD>
	</TR>
<?php 
	if ($GLOBALS["allow_torrent_move"] && function_exists("sha1"))
		echo "\t<TR>\r\n\t\t<TD ALIGN=CENTER COLSPAN=2><INPUT TYPE=\"checkbox\" NAME=\"copytorrent\" VALUE=\"enabled\" CHECKED> Copy torrent to torrent folder?&nbsp;<FONT SIZE=-1>Note: URL will be added automatically if selected.</FONT></TD>\r\n\t</TR>\r\n";

	if ($GLOBALS["allow_external_scanning"] && !$GLOBALS["auto_add_external_torrents"] && function_exists("sha1"))
		echo "\t<TR>\r\n\t\t<TD ALIGN=CENTER COLSPAN=2><INPUT TYPE=\"checkbox\" NAME=\"externaladd\" VALUE=\"enabled\" CHECKED> Add as an external reference (if applicable?)?&nbsp;<FONT SIZE=-1>Note: External tracker's announce URL must end with '/announce'.</FONT></TD>\r\n\t</TR>\r\n";

	if (function_exists("sha1")) {
		echo "\t<TR>\r\n\t\t<TD ALIGN=CENTER COLSPAN=2><INPUT TYPE=\"checkbox\" NAME=\"autoset\" VALUE=\"enabled\" CHECKED> Fill in fields using data from the torrent file</TD>\r\n\t</TR>\r\n"; 
	}
?>
	<TR>
		<TD ALIGN=CENTER COLSPAN=2><INPUT TYPE=submit NAME="addtorrent" VALUE="Add Torrent" CLASS="button">&nbsp;&nbsp;<INPUT TYPE=reset VALUE="Clear settings" CLASS="button"></TD>
	</TR>
	<TR>
		<TD COLSPAN=3 ALIGN="center"><BR><A HREF="bta_main.php">Return to Main Administrative screen.</A></TD>
	</TR>
	</TABLE>
	</TD>
</TR>
</TABLE> 
</FORM>
</BODY>
</HTML>